//=============================================================================
// zXcars - zxXcarUI : This is the UserInterface/ Hud for the car. (This gives the indecated speed and user Inputs for the vehicle.)
//				  By : -zXc-90-9-9ER-
//=============================================================================

/*
 zXcars is a modification for Deus Ex 1 which was developed by: Ion Storm Inc. and published by: Eidos Interactive on June 26, 2000.
 The mod gives the player(s) the ability to give cars within Deus Ex.
 Copyright (C) 2012  Justin Curr.

 This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License.
    
 This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class zXcarUI extends DeusExBaseWindow;

var bool bFirstFrameDone;

// -0- Information Panel (Fuel) (Speed)
var TextWindow winVehicleName;
var TextWindow winEngineStatus;
var TextWindow winSpeed;
var TextWindow winFuel;

var bool bWait;

var zXcar Owner_Vehicle;			// What Vehicle Owns this window

var Texture texBackground;
var Texture texBorder;

// Border and Background Translucency
var bool bBorderTranslucent;
var bool bBackgroundTranslucent;
var bool bDrawBorder;

var string Sample;
// Default Colors
var Color colBackground;
var Color colBorder;
var Color colHeaderText;

// ----------------------------------------------------------------------
// InitWindow()
//
// Initialize the Window
// ----------------------------------------------------------------------

event InitWindow()
{
	Super.InitWindow();

	SetWindowAlignments(HALIGN_Left, VALIGN_Center);
	SetSize(103, 162);
	SetMouseFocusMode(MFocus_EnterLeave);
	
	player.SetPhysics(PHYS_None);
	
	CreateInfoTextWindow();

	bTickEnabled = True;

	StyleChanged();
}

// ----------------------------------------------------------------------
// DestroyWindow()
//
// Destroys the Window
// ----------------------------------------------------------------------

event DestroyWindow()
{
	Owner_Vehicle.RecievedInput(0);
	
	Owner_Vehicle.Vehicle_Interface = None;
	Super.DestroyWindow();
}

// ----------------------------------------------------------------------
// InitData()
// 
// Do the post-InitWindow stuff
// ----------------------------------------------------------------------

function InitData()
{
	winVehicleName.SetTextColor(colHeaderText);
	winVehicleName.SetText("zXcars");
	
	winEngineStatus.SetTextColor(colHeaderText);
	winEngineStatus.SetText("Engine Off");
	
	winSpeed.SetTextColor(colHeaderText);
	winSpeed.SetText("0 - Km/H");
	
	winFuel.SetTextColor(colHeaderText);
	winFuel.SetText("0 - L");
	player.ClientMessage("zXcars - E : Toggle Engine");
	
}

// ----------------------------------------------------------------------
// Tick()
// ----------------------------------------------------------------------

function Tick(float deltaTime)
{
	local rotator Viewangle;
	if (!bFirstFrameDone)
	{
		SetCursorPos(width, height);
		bFirstFrameDone = True;
	}
	if(IsKeyDown(IK_NUMPAD2)){Viewangle.Yaw = 32767.999999999999999999999999992;}
	else if (IsKeyDown(IK_NUMPAD4)){Viewangle.Yaw = -8191.999999999999999999999999998;}
	else if (IsKeyDown(IK_NUMPAD6)){Viewangle.Yaw = 8191.999999999999999999999999998;}
	
	player.SetRotation(Owner_Vehicle.Rotation+Viewangle);
	player.ViewRotation = Owner_Vehicle.Rotation+Viewangle;
	player.LoopAnim('SitBreathe',0.15);
	
	//Updated movement
	if (IsKeyDown(IK_w) == false || IsKeyDown(IK_up) == false){Owner_Vehicle.RecievedInput(-1);}
	if (IsKeyDown(IK_s) == false || IsKeyDown(IK_down) == false){Owner_Vehicle.RecievedInput(-2);}
	if (IsKeyDown(IK_space) == false){Owner_Vehicle.RecievedInput(-5);}
	
	if (IsKeyDown(IK_a) == false || IsKeyDown(IK_left) == false){Owner_Vehicle.RecievedInput(-3);}
	if (IsKeyDown(IK_d) == false || IsKeyDown(IK_right) == false){Owner_Vehicle.RecievedInput(-4);}
	
	if (IsKeyDown(IK_w) || IsKeyDown(IK_up)){Owner_Vehicle.RecievedInput(1);}
	if (IsKeyDown(IK_s) || IsKeyDown(IK_down)){Owner_Vehicle.RecievedInput(2);}
	if (IsKeyDown(IK_space)){Owner_Vehicle.RecievedInput(5);}
	
	if (IsKeyDown(IK_a) || IsKeyDown(IK_left)){Owner_Vehicle.RecievedInput(3);}
	if (IsKeyDown(IK_d) || IsKeyDown(IK_right)){Owner_Vehicle.RecievedInput(4);}
	
	//Updated Vaues
		
	winSpeed.SetText(string(int(Owner_Vehicle.calculatedspeed)) @ " - Km/H");
	winFuel.SetText(string(int(Owner_Vehicle.Fuel)) @ " - L");
	
	if(Owner_Vehicle.Engine){winEngineStatus.SetText("(E)ngine On");}
	else{winEngineStatus.SetText("(E)ngine Off");}
}
// ----------------------------------------------------------------------
// DrawWindow()
// 
// DrawWindow event (called every frame)
// ----------------------------------------------------------------------

event DrawWindow(GC gc)
{
	// First draw the background then the border
	DrawBackground(gc);
	DrawBorder(gc);

	Super.DrawWindow(gc);
}

// ----------------------------------------------------------------------
// DrawBackground()
// ----------------------------------------------------------------------

function DrawBackground(GC gc)
{
	if (bBackgroundTranslucent)
		gc.SetStyle(DSTY_Translucent);
	else
		gc.SetStyle(DSTY_Masked);
	
	gc.SetTileColor(colBackground);

	gc.DrawTexture(0, 0, width, height, 0, 0, texBackground);
}

// ----------------------------------------------------------------------
// DrawBorder()
// ----------------------------------------------------------------------

function DrawBorder(GC gc)
{
	if (bDrawBorder)
	{
		if (bBorderTranslucent)
			gc.SetStyle(DSTY_Translucent);
		else
			gc.SetStyle(DSTY_Masked);
		
		gc.SetTileColor(colBorder);

		gc.DrawTexture(0, 0, width, height, 0, 0, texBorder);
	}
}

// ----------------------------------------------------------------------
// CreateUIButtons()
// ----------------------------------------------------------------------

function CreateInfoTextWindow()
{
	winVehicleName = TextWindow(NewChild(Class'TextWindow'));
	winVehicleName.SetPos(17, 21);
	winVehicleName.SetSize(75, 11);
	winVehicleName.SetTextMargins(0, 0);
	winVehicleName.SetTextAlignments(HALIGN_Center, VALIGN_Center);
	winVehicleName.SetFont(Font'FontMenuSmall');
	winVehicleName.SetTextColor(colHeaderText);
	winVehicleName.SetText("zXcars");
	
	winEngineStatus = TextWindow(NewChild(Class'TextWindow'));
	winEngineStatus.SetPos(17, 21+14);
	winEngineStatus.SetSize(75, 11);
	winEngineStatus.SetTextMargins(0, 0);
	winEngineStatus.SetTextAlignments(HALIGN_Center, VALIGN_Center);
	winEngineStatus.SetFont(Font'FontMenuSmall');
	winEngineStatus.SetTextColor(colHeaderText);
	winEngineStatus.SetText("Engine Off");
	
	winSpeed = TextWindow(NewChild(Class'TextWindow'));
	winSpeed.SetPos(17, 21+14+14);
	winSpeed.SetSize(75, 11);
	winSpeed.SetTextMargins(0, 0);
	winSpeed.SetTextAlignments(HALIGN_Center, VALIGN_Center);
	winSpeed.SetFont(Font'FontMenuSmall');
	winSpeed.SetTextColor(colHeaderText);
	winSpeed.SetText("0 - Km/h");
	
	winFuel = TextWindow(NewChild(Class'TextWindow'));
	winFuel.SetPos(17, 21+14+14+14);
	winFuel.SetSize(75, 11);
	winFuel.SetTextMargins(0, 0);
	winFuel.SetTextAlignments(HALIGN_Center, VALIGN_Center);
	winFuel.SetFont(Font'FontMenuSmall');
	winFuel.SetTextColor(colHeaderText);
	winFuel.SetText("0 - L");
}

// ----------------------------------------------------------------------
// VirtualKeyPressed()
//
// Called when a key is pressed; provides a virtual key value
// ----------------------------------------------------------------------

event bool VirtualKeyPressed(EInputKey key, bool bRepeat)
{
	local bool bKeyHandled;

	bKeyHandled = True;

	if (IsKeyDown(IK_Alt) || IsKeyDown(IK_Ctrl))
		return False;

	if (!bRepeat)
	{
		switch(key) 
		{	
			case IK_e:	Owner_Vehicle.RecievedInput(6); break; //-: Vehicle engine.
			case IK_q:	DestroyWindow(); break; //-: Vehicle engine.
			default:	bKeyHandled = False;
		}
	}

	if (!bKeyHandled)
		return Super.VirtualKeyPressed(key, bRepeat);
	else
		return bKeyHandled;
}

// ----------------------------------------------------------------------
// StyleChanged()
// ----------------------------------------------------------------------

event StyleChanged()
{
	local ColorTheme theme;

	theme = player.ThemeManager.GetCurrentHUDColorTheme();

	colBackground = theme.GetColorFromName('HUDColor_Background');
	colBorder     = theme.GetColorFromName('HUDColor_Borders');
	colHeaderText = theme.GetColorFromName('HUDColor_HeaderText');

	bBorderTranslucent     = player.GetHUDBorderTranslucency();
	bBackgroundTranslucent = player.GetHUDBackgroundTranslucency();
	bDrawBorder            = player.GetHUDBordersVisible();
}

// ----------------------------------------------------------------------
// ----------------------------------------------------------------------

defaultproperties
{
     texBackground=Texture'zXcars_beta03.VehicleUI.VehicleUIBackground'
     texBorder=Texture'DeusExUI.UserInterface.HUDKeypadBorder'
}
